include     MergeFile.inc

ParseCmdLine PROTO :DWORD

.data

welcome     db 'MergeFile V1.0 - Tool to merge two files',13,10
            db '                 MergeFile writes also the size of filename2',13,10
            db '                 to the end of the merged files'
            db 13,10,13,10
            db 'Usage : MergeFile filename1.ext filename2.ext',13,10,0
success     db 'file modified successfully',13,10,13,10,0
readfail    db 'cannot read file2',0
writefail   db 'cannot write to file1',0
mallocfail  db 'memory allocation failure',0

.data?

cmdline     dd 512 dup(?)
hFile       dd ?
fSize       dd ?
bBytes      dd ?
pMem        dd ?

.code

start:

    mov     esi,OFFSET cmdline
    invoke  ParseCmdLine,esi
    mov     edi,OFFSET welcome
    cmp     eax,3
    jne     _exit

    invoke  CreateFile,DWORD PTR [esi+8],GENERIC_READ,\
            0,0,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,0
    mov     edi,OFFSET readfail            
    cmp     eax,INVALID_HANDLE_VALUE
    je      _exit

    mov     hFile,eax
    invoke  GetFileSize,eax,0
    mov     fSize,eax
    add     eax,SIZEOF DWORD
    invoke  VirtualAlloc,0,eax,MEM_COMMIT,PAGE_READWRITE
    mov     edi,OFFSET mallocfail
    test    eax,eax
    jz      CloseFileExit
      
    mov     pMem,eax    
    invoke  ReadFile,hFile,eax,fSize,ADDR bBytes,0
    mov     edi,OFFSET readfail
    test    eax,eax
    jz      FreeMemExit
    invoke  CloseHandle,hFile

    invoke  CreateFile,DWORD PTR [esi+4],GENERIC_WRITE,\
            0,0,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,0
    mov     edi,OFFSET writefail            
    cmp     eax,INVALID_HANDLE_VALUE
    je      FreeMemExit

    mov     hFile,eax
    invoke  SetFilePointer,eax,0,0,FILE_END
    mov     edx,fSize
    push    edx
    lea     eax,[edx+4]
    add     edx,pMem
    pop     DWORD PTR [edx]
    invoke  WriteFile,hFile,pMem,eax,ADDR bBytes,0
    mov     edi,OFFSET writefail
    test    eax,eax
    jz      FreeMemExit
    mov     edi,OFFSET success

FreeMemExit:

    invoke  VirtualFree,pMem,0,MEM_RELEASE

CloseFileExit:

    invoke  CloseHandle,hFile

_exit:

    invoke  StdOut,edi
    invoke  ExitProcess,0

END start
