include     MergeFile\MergeFile.inc

.data

DllName     db 'Console.dll',0
func        db 'StdOut',0
message     db 'StdOut called from Console.dll',13,10,0
filename    db 'Testdll.exe',0
readfail    db 'cannot read Testdll.exe',0
writefail   db 'cannot write the destination file Console.dll',0
mallocfail  db 'memory allocation failure',0
loadlibfail db 'cannot load the DLL',0
getprocfail db 'cannot call StdOut exported by Console.dll',0

.data?

hFile       dd ?
bBytes      dd ?
hInst       dd ?
fSize       dd ?
pMem        dd ?

.code

start:

    invoke  CreateFile,ADDR filename,GENERIC_READ,\
            0,0,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,0
    mov     edi,OFFSET readfail
    cmp     eax,INVALID_HANDLE_VALUE
    je      _exit
        
    mov     hFile,eax
    invoke  SetFilePointer,eax,-SIZEOF DWORD,0,FILE_END
    mov     esi,eax
    invoke  ReadFile,hFile,ADDR fSize,SIZEOF DWORD,ADDR bBytes,0
    test    eax,eax
    jz      CloseFileExit

    sub     esi,fSize
    invoke  SetFilePointer,hFile,esi,0,FILE_BEGIN

    invoke  VirtualAlloc,0,fSize,MEM_COMMIT,PAGE_READWRITE
    mov     edi,OFFSET mallocfail
    test    eax,eax
    jz      CloseFileExit
    
    mov     pMem,eax
    invoke  ReadFile,hFile,eax,fSize,ADDR bBytes,0
    mov     edi,OFFSET readfail
    test    eax,eax
    jz      FreeMemExit
    invoke  CloseHandle,hFile

    invoke  CreateFile,ADDR DllName,GENERIC_WRITE,0,0,\
            CREATE_ALWAYS,FILE_ATTRIBUTE_ARCHIVE,0
    mov     edi,OFFSET writefail
    cmp     eax,INVALID_HANDLE_VALUE
    je      FreeMemExit
    
    mov     hFile,eax
    invoke  WriteFile,eax,pMem,fSize,ADDR bBytes,0
    mov     edi,OFFSET writefail
    test    eax,eax
    jz      FreeMemExit
    invoke  CloseHandle,hFile
    invoke  VirtualFree,pMem,0,MEM_RELEASE

    invoke  LoadLibrary,ADDR DllName
    mov     edi,OFFSET loadlibfail
    test    eax,eax
    jz      _exit
        
    mov     hInst,eax
    invoke  GetProcAddress,eax,ADDR func
    mov     edi,OFFSET getprocfail
    test    eax,eax
    jz      _exit

    invoke  pr1 PTR eax,ADDR message
    invoke  FreeLibrary,hInst
    jmp     _exit2

FreeMemExit:

    invoke  VirtualFree,pMem,0,MEM_RELEASE

CloseFileExit:

    invoke  CloseHandle,hFile
    
_exit:

    invoke  StdOut,edi

_exit2:

    invoke  ExitProcess,0
    
END start
